/**
 * @file som9260atod_test.c
 *
 * Example application for accessing the EMAC interface for the
 * on-module AtoD on the SoM-9260M. This interface uses the EMAC
 * ioex class to provide a GPIO-like interface (see also the egpc
 * project).
 * 
 * @author EMAC, Inc. <support@emacinc.com>
 *
 * Copyright (C) 2009 EMAC, Inc.
 */
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <sys/types.h>
#include <asm/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdint.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "gpio_char.h" /* get the ioctl commands */


int main(int argc, char *argv[])
{
	__u32 index;
	__u32 data;
        int file_des;

	if ((file_des = open("/dev/indexed_atod", O_RDWR)) == -1) {
		fprintf(stderr,"Error opening device file: %s\n", strerror(errno));
		return -1;
	}

	for(index = 0; index < 4; index++)
	{
		/* set the index */
		if (ioctl(file_des, INDEXWRITE, &index) == -1) {
			fprintf(stderr,"error setting index: %s\n", strerror(errno));
			return -1;
		}
		/* read the data */
		if (ioctl(file_des, DATAREAD, &data) == -1) {
			fprintf(stderr,"error reading data\n");
			return -1;
		}
		printf("[%d] = %d\n", index, data);
	}

	close(file_des);
	return 0;
}

